Elgoh.frmEDB = CreateFrame("Frame", "Elgoh.frmEDB")

local playername=(UnitName("PLAYER"));

EDB={};

Elgoh.frmEDB:SetScript("OnEvent", Elgoh.onEvent);
Elgoh.frmEDB:RegisterEvent("ADDON_LOADED");
Elgoh.frmEDB:RegisterEvent("CHAT_MSG_ADDON");

function Elgoh_ResizeGuildFrame()
	if(CanEditOfficerNote()==false) then
		GuildMemberDetailFrame:SetHeight(GuildMemberDetailFrame:GetHeight()+25);
	else
		GuildMemberDetailFrame:SetHeight(GuildMemberDetailFrame:GetHeight()+70);
	end
end

function Elgoh.CreateGuildFrame()
	if (GuildMemberDetailFrame) then		
		EDBDKPText = GuildMemberDetailFrame:CreateFontString("EDBDKPText", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("LEFT");
		EDBDKPText:SetPoint("TOPLEFT", GuildMemberNoteBackground, "BOTTOMLEFT", 5, -5);
		
		EDBThreshText = GuildMemberDetailFrame:CreateFontString("EDBThreshText", "ARTWORK", "GameFontNormal");
		EDBThreshText:SetHeight(10);
		EDBThreshText:SetJustifyH("RIGHT");
		EDBThreshText:SetPoint("TOPRIGHT", GuildMemberNoteBackground, "BOTTOMRIGHT", -5, -5);
		
		GuildMemberDetailOfficerNoteLabel:ClearAllPoints();
		GuildMemberDetailOfficerNoteLabel:SetPoint("TOPLEFT", EDBDKPText, "BOTTOMLEFT", -5, -10);
		
		GUILD_DETAIL_NORM_HEIGHT = 212;
		GUILD_DETAIL_OFFICER_HEIGHT = 310;
		
		if(CanEditOfficerNote()==true) then
			EDBAwardGP = CreateFrame("Button", "EDBAwardGP", GuildMemberDetailFrame, "UIPanelButtonTemplate");
			EDBAwardGP:SetWidth(40);
			EDBAwardGP:SetHeight(40);
			EDBAwardGP:SetText("GP");
			EDBAwardGP:SetPoint("TOPRIGHT", EDBThreshText, "BOTTOMRIGHT", 10,-10);
			EDBAwardGP:SetScript("OnClick", function() Elgoh.GrantEPGP("GP", tonumber(EDBAmountBox:GetText()), EDB.selected, false, EDBReasonBox:GetText()); EDBReasonBox:ClearFocus(); EDBAmountBox:ClearFocus(); end)
			
			EDBAwardEP = CreateFrame("Button", "EDBAwardEP", GuildMemberDetailFrame, "UIPanelButtonTemplate");
			EDBAwardEP:SetWidth(40);
			EDBAwardEP:SetHeight(40);
			EDBAwardEP:SetText("EP");
			EDBAwardEP:SetPoint("TOPLEFT", EDBDKPText, "BOTTOMLEFT", -10,-10);
			EDBAwardEP:SetScript("OnClick", function() Elgoh.GrantEPGP("EP", tonumber(EDBAmountBox:GetText()), EDB.selected, false, EDBReasonBox:GetText()); EDBReasonBox:ClearFocus(); EDBAmountBox:ClearFocus(); end);
			
			EDBAmountBox = CreateFrame("EditBox", "EDBAmountBox", GuildMemberDetailFrame, "InputBoxTemplate")
			EDBAmountBox:SetHeight(20)
			EDBAmountBox:SetPoint("TOPLEFT", EDBAwardEP, "TOPRIGHT", 5,0);
			EDBAmountBox:SetPoint("RIGHT", EDBAwardGP, "LEFT", 0,0);
			EDBAmountBox:SetAutoFocus(false)
			EDBAmountBox:SetJustifyH("CENTER");
			EDBAmountBox:SetText("Value");
			EDBAmountBox:SetScript("OnEnterPressed", function() EDBAmountBox:ClearFocus(); end)
			
			EDBReasonBox = CreateFrame("EditBox", "EDBReasonBox", GuildMemberDetailFrame, "InputBoxTemplate")
			EDBReasonBox:SetHeight(20)
			EDBReasonBox:SetPoint("BOTTOMLEFT", EDBAwardEP, "BOTTOMRIGHT", 5,0);
			EDBReasonBox:SetPoint("RIGHT", EDBAwardGP, "LEFT", 0,0);
			EDBReasonBox:SetAutoFocus(false)
			EDBReasonBox:SetJustifyH("CENTER");
			EDBReasonBox:SetText("Reason");
			EDBReasonBox:SetScript("OnEnterPressed", function() EDBReasonBox:ClearFocus(); end);
			
			GuildMemberDetailOfficerNoteLabel:ClearAllPoints();
			GuildMemberDetailOfficerNoteLabel:SetPoint("TOPLEFT", EDBAwardEP, "BOTTOMLEFT", 5, -6);
			
			ElgohGuildManagement=CreateFrame("Button","ElgohGuildManage",GuildFrame,"UIPanelButtonTemplate")
			ElgohGuildManagement:SetWidth(40)
			ElgohGuildManagement:SetHeight(40)
			ElgohGuildManagement:SetPoint("TOPLEFT", GuildFrame, "TOPLEFT", 60, -25);
			ElgohGuildManagement:SetScript("OnClick", function() ElgohFrame:Show(); end);
			ElgohGuildManagement:SetNormalTexture("Interface/Icons/spell_warlock_demonsoul");
		end
	end
end

function ElgohGuildRoster_SetView(view)
	local GUILD_ROSTER_MAX_COLUMNS = 5;
	local GUILD_ROSTER_MAX_STRINGS = 4;
	local GUILD_ROSTER_BAR_MAX = 239;
	local GUILD_ROSTER_BUTTON_OFFSET = 2;
	local GUILD_ROSTER_BUTTON_HEIGHT = 20;
	
	local GUILD_ROSTER_COLUMNS = {
		playerStatus = { "level", "class", "wideName", "zone" },
		guildStatus = { "name", "rank", "note", "online" },
		weeklyxp = { "level", "class", "wideName", "weeklyxp" },
		totalxp = { "level", "class", "wideName", "totalxp" },
		pvp = { "level", "class", "name", "bgrating", "arenarating" },
		achievement = { "level", "class", "wideName", "achievement" },
		tradeskill = { "wideName", "zone", "skill" },
		reputation = { "level", "class", "wideName", "reputation" },
		epgp = { "name", "rank", "priority" },
	};
	if ( view~="epgp") then return; end
	
	local numColumns = #GUILD_ROSTER_COLUMNS[view];
	local stringsInfo = { };
	local stringOffset = 0;
	local haveIcon, haveBar;
	
	-- set up columns
	for columnIndex = 1, 5 do
		local columnButton = _G["GuildRosterColumnButton"..columnIndex];
		local columnType = GUILD_ROSTER_COLUMNS[view][columnIndex];
		if ( columnType ) then
			local columnData = GUILD_ROSTER_COLUMN_DATA[columnType];
			columnButton:SetText(columnData.text);
			WhoFrameColumn_SetWidth(columnButton, columnData.width);
			columnButton:Show();
			-- by default the sort type should be the same as the column type
			if ( columnData.sortType ) then
				columnButton.sortType = columnData.sortType;
			else
				columnButton.sortType = columnType;
			end
			if ( columnData.hasIcon ) then
				haveIcon = true;
			else 
				-- store string data for processing
				columnData["stringOffset"] = stringOffset;
				table.insert(stringsInfo, columnData);
			end
			stringOffset = stringOffset + columnData.width - 2;
			haveBar = haveBar or columnData.hasBar;
		else
			columnButton:Hide();
		end
	end
	
	-- process the button strings
	local buttons = GuildRosterContainer.buttons;
	local button, fontString;
	for buttonIndex = 1, #buttons do
		button = buttons[buttonIndex];
		for stringIndex = 1, 4 do
			fontString = button["string"..stringIndex];
			local stringData = stringsInfo[stringIndex];
			if ( stringData ) then
				-- want strings a little inside the columns, 6 pixels from the left and 8 from the right
				fontString:SetPoint("LEFT", stringData.stringOffset + GUILD_ROSTER_STRING_OFFSET, 0);
				fontString:SetWidth(stringData.width - GUILD_ROSTER_STRING_WIDTH_ADJ);
				fontString:SetJustifyH(stringData.stringJustify);
				fontString:Show();
			else
				fontString:Hide();
			end
		end
		
		if ( haveIcon ) then
			button.icon:Show();
		else
			button.icon:Hide();
		end
		if ( haveBar ) then
			button.barLabel:Show();
			-- button.barTexture:Show(); -- shown status determined in GuildRoster_Update 
		else
			button.barLabel:Hide();
			button.barTexture:Hide();
		end
		button.header:Hide();
	end
	currentGuildView = view;
end

function ElgohGuildRosterViewDropdown_Initialize()
	local info = UIDropDownMenu_CreateInfo();
	info.func = GuildRosterViewDropdown_OnClick;
	
	info.text = "Priority";
	info.value = "epgp";
	UIDropDownMenu_AddButton(info);
end

function Elgoh.GuildFrameUpdated()
	local pname= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if(pname == EDB.selected) then return end
		EDB.selected = pname;
		Elgoh.Snapshot(UnitName("PLAYER"));
		Elgoh.Snapshot(pname);
		Elgoh.UpdateLines(EDB.selected);
	end
end

function Elgoh.UpdateLines(who)
	EDBDKPText:SetText("");
	local EPGPThreshhold=Elgoh.Settings["EPGPThreshhold"];
	if(EDB[who]) then
		if(who~=playername) then
			if(EDB[playername] and EDB[playername]["priority"]~=nil) then
				if(EDB[who]["priority"]) then
					EDBDKPText:SetText("EP/GP: "..EDB[who]["priority"]);
					EDBDKPText:SetTextColor(0.2,1,0.2);
					if((EDB[playername]["earned"]>EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) or (EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]<EPGPThreshhold)) then
						if(EDB[who]["priority"]>EDB[playername]["priority"]) then
							EDBDKPText:SetTextColor(1,0.2,0.2);
						end
					elseif(EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) then
						EDBDKPText:SetTextColor(1,0.2,0.2);
					end
				end
			end
		else
			EDBDKPText:SetText("EP/GP: "..EDB[playername]["priority"]);
			EDBDKPText:SetTextColor(1,1,1);			
		end
		if(EDB[who]["earned"]>EPGPThreshhold) then EDBThreshText:SetTextColor(0.2,1,0.2); EDBThreshText:SetText("Above "..EPGPThreshhold); else EDBThreshText:SetTextColor(1,0.2,0.2); EDBThreshText:SetText("Below "..EPGPThreshhold); end
	end
end

function Elgoh.LoadValues(who)
	if(GL_DKPValues['empty']==true) then 
		ElPrint("The GuildLaunch file is empty, please download a fresh copy from your website");
		return; 
	end
	EDB[who]={};
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
			if(GL_DKPValues["current_dkp_data"][name:lower()]~=nil) then
				EDB[name].earned=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				EDB[name].spent=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				EDB[name].priority=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
			else
				EDB[name].earned=0;
				EDB[name].spent=0;
				EDB[name].priority=0;
			end
			Elgoh.ToNote(name);
		end
	end
end

function Elgoh.ToNote(who)
	if(CanEditOfficerNote()==false) then ElPrint("I can't let you do that, "..playername); return; end
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);	
		if(who==nil or name==who) then
			if(EDB[who].earned~=0) then
				if(EDB[who].spent~=0) then
					EDB[who].priority=(floor(((EDB[who].earned/EDB[who].spent)*100) + 0.5 )) /100;
				else
					EDB[who].priority=EDB[who].earned;
				end
			end
			local oNote=strjoin(":","$"..EDB[name]["earned"], EDB[name]["spent"], EDB[name]["priority"].."$");
			GuildRosterSetOfficerNote(i, oNote);
		end
	end
end

function Elgoh.Snapshot(who)
	if(CanEditOfficerNote()==false) then QueryOfficer(who); return; end
	for i = 1, GetNumGuildMembers(), 1 do
		local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
		if(name==who) then
			local EDBString=string.match(officernote, "%$(.*)%$");
			if(EDBString==nil) then 
				ElDebug("No DKP String found: Restoring "..name); 
				Elgoh.LoadValues(name); 
				Elgoh.ToNote(who);
				return; 
			end
			
			local Earned,Spent,Priority=strsplit(":",EDBString);
			Earned=tonumber(Earned);
			Spent=tonumber(Spent);
			Priority=tonumber(Priority);
			
			if(Earned==nil or Spent==nil or Priority==nil) then ElPrint("Invalid EPGP string found: Reloading "..name); Elgoh.LoadValues(name); return; end
			
			if(Priority~=(floor(((Earned/Spent)*100) + 0.5 ))/100 and Priority~=0 and Priority~=Earned) then 
				ElPrint("Edited EPGP string found (values have been altered): Reloading "..name); 
				Elgoh.LoadValues(name); 
				Elgoh.ToNote(who);
				SendChatMessage("Warning: EPGP for "..name.." had been edited", "OFFICER");
				return; 
			end
			
			EDB[name]={}
			EDB[name]["earned"]=Earned;
			EDB[name]["spent"]=Spent;
			EDB[name]["priority"]=Priority;
			if(who~=nil) then return; end
		end
	end
	ElDebug("Snapshotted Everyone");
end

function Elgoh.Wipe()
for i = 1, GetNumGuildMembers(), 1 do
		local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
		EDB[name]={}
		EDB[name]["earned"]=0;
		EDB[name]["spent"]=0;
		EDB[name]["priority"]=0;
		Elgoh.ToNote(name);
	end
	ElPrint("Guild EPGP Reset");
end

function QueryOfficer(who)
	ElgohWaitingOnOfficer=true;
	Elgoh.frmEDB:SetScript("OnUpdate", Elgoh.frmEDB.OnUpdate);
	Elgoh.frmEDB.TimeSinceLastUpdate=0;
	SendAddonMessage("elgoh", "!"..who, "GUILD");
end

function Elgoh.frmEDB.OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	
	
	if(self.TimeSinceLastUpdate>=0.5) then
		if(ElgohWaitingOnOfficer==true) then
			EDBDKPText:SetText("No Officer Replies");
		end
		self.TimeSinceLastUpdate = 0;
		ElgohWaitingOnOfficer=false;
		self:SetScript("OnUpdate", nil);
	end
end

function Elgoh.GrantEPGP(EPGP, amount, who, mass, reason)
	if(EPGP=="EP") then values="earned"; else values="spent"; end
	if(amount=="Value" or amount==nil) then ElPrint("You need to insert a value"); return; end
	if(reason=="Reason" or reason=="") then reason=nil; end
	local msg="";
	if mass then
		if(who=="guild") then
			for i = 1, GetNumGuildMembers(), 1 do
				local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
				Elgoh.Snapshot(name);
				EDB[name][values]=EDB[name][values]+amount;
				Elgoh.ToNote(name);
			end
			msg=GetNumGuildMembers().." peoples "..EPGP.." has been changed by "..amount;
		else
			for i=1,#who do
				Elgoh.Snapshot(who[i]);
				EDB[who[i]][values]=EDB[who[i]][values]+amount;
				Elgoh.ToNote(who[i]);
			end
			msg=#who.." peoples "..EPGP.." has been changed by "..amount;
		end
		if(reason~=nil) then msg=msg.." for "..reason; end
		SendChatMessage(msg, "OFFICER");
	else
		Elgoh.Snapshot(who);
		EDB[who][values]=EDB[who][values]+amount;
		Elgoh.ToNote(who);
		local msg=who.."'s "..EPGP.." has been changed by "..amount;
		if(reason~=nil) then msg=msg.." for "..reason; end
		SendChatMessage(msg, "OFFICER");
		if(EDBDKPText~=nil) then Elgoh.UpdateLines(EDB.selected); end
	end
end

function Elgoh.DKPWhisper(who)
	Elgoh.Snapshot(who);
	if (EDB[who]~=nil) then
		SendChatMessage("Detailed Results for "..who..":", "WHISPER", nil, who);
		SendChatMessage("EP: "..EDB[who]["earned"], "WHISPER", nil, who);
		SendChatMessage("GP: "..EDB[who]["spent"], "WHISPER", nil, who);
		SendChatMessage("Priority: "..EDB[who].priority, "WHISPER", nil, who);
	else
		SendChatMessage("No DKP exists for "..who, "WHISPER", nil, who);
	end		
end