function Elgoh.LootButton(spec, item)
	LootingReset();
	local item=item*LootFrame.page;
	Elgoh.currentItem=GetLootSlotLink(item);
	if Elgoh.currentItem==nil then return; end
	if(spec=="MS" or spec=="OS") then
		local message;
		ElgohRolling=1;
		if(spec=="MS") then
			message=string.gsub(Elgoh.Settings["MSString"], "ITEM", Elgoh.currentItem)
		elseif(spec=="OS") then
			message=string.gsub(Elgoh.Settings["OSString"], "ITEM", Elgoh.currentItem)
		end
		EDebug(message);
		SendChatMessage(message, "RAID_WARNING");
	else
		Elgoh_Handout("DE");
	end
end

local winner="";
function Elgoh_RaiderInterested(name)
	if(ElgohRolling==0) then return; end
	for i=1,#InterestedRaiders do
		if(InterestedRaiders[i]==name) then return; end
	end
	EDB_Snapshot(name);
	tinsert(InterestedRaiders, name);
	local oldWinner=winner;
	Elgoh_RefreshLootList();
	if(EDB[InterestedRaiders[2]]~=nil and (EDB[InterestedRaiders[1]].earned==EDB[InterestedRaiders[2]].earned) and (EDB[InterestedRaiders[1]].spent==EDB[InterestedRaiders[2]].spent)) then
		SendChatMessage("There is an EP/GP tie-break situation", "RAID");
		return;
	end
	if(winner==oldWinner) then 
		SendChatMessage(winner.." is still winning with EP/GP: "..EDB[winner].priority, "RAID"); 
	else 
		SendChatMessage(winner.." is our new winner with EP/GP: "..EDB[winner].priority, "RAID");
	end
end

function LootingReset()
	InterestedRaiders={};
	ElgohRolling=0;
	winner="";
	Elgoh.currentItem="";
	if(ElgohLootFrame~=nil) then ElgohLootFrame:Hide(); end
end

function Elgoh.Handout(price)
	local item=Elgoh.currentItem;
	if(price=="free") then 
		itemCost=0; item=item.." (free)";
	elseif(price=="DE") then
		if(Elgoh.disenchanter=="your Disenchanter") then
			winner=UnitName("PLAYER");
			ElPrint("Disenchanter not set, giving to you...");
		else
			winner=Elgoh.disenchanter;
		end
		itemCost=0; item=item.." (Disenchanted)";
	else
		itemLevel,itemCost = ElgohiLvl(string.sub(Elgoh.currentItem,2,-2));
		if(itemCost==0 and IsShiftKeyDown()~=1) then ElPrint("Item returned a cost of 0, please hover over the item to cache it then try again (or shift click to force)"); return; end
		if(price=="OS") then itemCost=itemCost/2; item=item.." (offspec)"; end
	end
	EDB_GrantEPGP("GP", math.floor(itemCost), winner, false, item)
	--EDebug("GP, "..itemCost..", "..winner..", "..Elgoh.currentItem);
	for i=1,GetNumLootItems()+1 do
		local _,lootName = GetLootSlotInfo(i);
		EDebug(lootName.." - "..Elgoh.currentItem);
		item=string.match(Elgoh.currentItem, "%[(.+)%]");
		if(lootName==item) then
			for r=0,GetNumGroupMembers() do
				candidate = GetMasterLootCandidate(i, r);
				if(candidate==winner) then 
					GiveMasterLoot(i, r);
					LootingReset();
					return;
				end
			end
		end
	end
	ElPrint("Loot not eligible for auto-handout");
	LootingReset();
end

function ElgohLoot_OnEnter(self)
	GameTooltip:SetOwner(ElgohLootFrame, "ANCHOR_TOP" );
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1 );
end

function Elgoh_RefreshLootList()
	if(ElgohLootFrame==nil) then
		ElgohLootFrame=CreateFrame("Frame","ElgohLootFrame",UIParent,"BasicFrameTemplate");
		ElgohLootFrame:SetHeight(150);
		ElgohLootFrame:SetWidth(150);
		ElgohLootFrame:SetPoint("CENTER", UIParent, "CENTER");
		-- ElgohLootFrameTitleText:SetText("Elgoh EPGP");
		-- ElgohLootFrameCloseButton:SetScript("OnClick", function() ElgohLootFrame:Hide(); LootingReset(); end);
		-- ElgohLootFrameCloseButton:HookScript("OnClick", LootingReset);
		-- ElgohLootFrameCloseButton:HookScript("OnEnter", ElgohLoot_OnEnter);
		-- ElgohLootFrameCloseButton:HookScript("OnLeave", GameTooltip_Hide);
		-- ElgohLootFrameCloseButton.tooltipText="End the roll";
		
		Elgoh_AllowToMove(ElgohLootFrame);
		
		ElgohLootFinishedMSButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedMSButton:SetPoint("BOTTOMLEFT", ElgohLootFrame, "BOTTOMLEFT", -2,20)
		ElgohLootFinishedMSButton:SetWidth(75);
		ElgohLootFinishedMSButton:SetHeight(22);
		ElgohLootFinishedMSButton:SetText("Give MS");
		ElgohLootFinishedMSButton:SetScript("OnClick", function() Elgoh.Handout("MS"); end);
		ElgohLootFinishedMSButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedMSButton.tooltipText="";
		ElgohLootFinishedMSButton:SetScript( "OnLeave", GameTooltip_Hide);
		
		ElgohLootFinishedOSButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedOSButton:SetPoint("BOTTOMRIGHT", ElgohLootFrame, "BOTTOMRIGHT", 0,20)
		ElgohLootFinishedOSButton:SetWidth(75);
		ElgohLootFinishedOSButton:SetHeight(22);
		ElgohLootFinishedOSButton:SetText("Give OS");
		ElgohLootFinishedOSButton:SetScript("OnClick", function() Elgoh.Handout("OS"); end);
		ElgohLootFinishedOSButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedOSButton.tooltipText="";
		ElgohLootFinishedOSButton:SetScript( "OnLeave", GameTooltip_Hide);
		
		ElgohLootFinishedFreeButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedFreeButton:SetPoint("BOTTOMRIGHT", ElgohLootFrame, "BOTTOMRIGHT", 0,0)
		ElgohLootFinishedFreeButton:SetWidth(75);
		ElgohLootFinishedFreeButton:SetHeight(22);
		ElgohLootFinishedFreeButton:SetText("Give Free");
		ElgohLootFinishedFreeButton:SetScript("OnClick", function() Elgoh.Handout("free"); end);
		ElgohLootFinishedFreeButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedFreeButton.tooltipText="";
		ElgohLootFinishedFreeButton:SetScript( "OnLeave", GameTooltip_Hide);		
		
		ElgohLootFinishedDEButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ElgohLootFinishedDEButton:SetPoint("BOTTOMLEFT", ElgohLootFrame, "BOTTOMLEFT", -2,0)
		ElgohLootFinishedDEButton:SetWidth(75);
		ElgohLootFinishedDEButton:SetHeight(22);
		ElgohLootFinishedDEButton:SetText("Disenchant");
		ElgohLootFinishedDEButton:SetScript("OnClick", function() Elgoh.Handout("DE"); end);
		ElgohLootFinishedDEButton:SetScript("OnEnter", ElgohLoot_OnEnter);
		ElgohLootFinishedDEButton.tooltipText="";
		ElgohLootFinishedDEButton:SetScript( "OnLeave", GameTooltip_Hide);
	end
	table.sort(InterestedRaiders, Elgoh_SortLooters);	
	for i=1, 5 do
		if(ElgohLooters[i]==nil) then
			ElgohLooters[i] = ElgohLootFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal");
			ElgohLooters[i]:SetHeight(10);
			ElgohLooters[i]:SetPoint("TOPLEFT", ElgohLootFrame, "TOPLEFT", 30, -16-(15*i));
			ElgohLooters[i]:Hide();
			
			ElgohLooters[i+5] = CreateFrame("CheckButton", nil, ElgohLootFrame, "InterfaceOptionsCheckButtonTemplate");
			ElgohLooters[i+5]:SetPoint("CENTER", ElgohLooters[i], "CENTER", 0, 0 );
			ElgohLooters[i+5]:SetPoint("RIGHT", ElgohLooters[i], "LEFT", 0, 0 );
			ElgohLooters[i+5]:SetScript("OnClick", function() Elgoh.LootCheckBox(i); end);
			ElgohLooters[i+5]:Hide();
		end
		if(InterestedRaiders[i]~=nil) then
			ElgohLooters[i]:SetText(i..") "..InterestedRaiders[i]);
			ElgohLooters[i]:Show();
			ElgohLooters[i+5]:Show();
		else 
			ElgohLooters[i]:Hide(); 
			ElgohLooters[i+5]:Hide(); 
		end
	end
	Elgoh.LootCheckBox(1);
	if(#InterestedRaiders>0) then 
		ElgohLootFrame:Show();
		local itemLevel,itemCost = ElgohiLvl(string.sub(Elgoh.currentItem,2,-2));
		itemCost=math.floor(itemCost);
		ElgohLootFinishedMSButton.tooltipText="Charge "..winner.." "..itemCost.." GP for:\n"..Elgoh.currentItem;
		ElgohLootFinishedOSButton.tooltipText="Charge "..winner.." "..math.floor(itemCost)*Elgoh.Settings.OSDiscount.." GP for:\n"..Elgoh.currentItem;
		ElgohLootFinishedFreeButton.tooltipText="Charge "..winner.." 0 GP for:\n"..Elgoh.currentItem;
		ElgohLootFinishedDEButton.tooltipText="Send "..Elgoh.currentItem.." to "..Elgoh.disenchanter;
	else 
		ElgohLootFrame:Hide(); 
		return;
	end
end

function Elgoh.LootCheckBox(box)
	for i=1,5 do
		ElgohLooters[i+5]:SetChecked(0);
	end
	ElgohLooters[box+5]:SetChecked(1);
	winner=InterestedRaiders[box];
	ElgohLootFinishedMSButton.tooltipText="Charge "..winner.." "..itemCost.." GP for:\n"..Elgoh.currentItem;
	ElgohLootFinishedOSButton.tooltipText="Charge "..winner.." "..math.floor(itemCost)*Elgoh.Settings.OSDiscount.." GP for:\n"..Elgoh.currentItem;
	ElgohLootFinishedFreeButton.tooltipText="Charge "..winner.." 0 GP for:\n"..Elgoh.currentItem;
end

function Elgoh.SortLooters(a,b)
	EDB.Snapshot(a);
	EDB.Snapshot(b);
	local EPGPT=Elgoh.Settings["EPGPThreshhold"];
	if((EDB[a]["earned"]>EPGPT and EDB[b]["earned"]>EPGPT) or (EDB[a]["earned"]<EPGPT and EDB[b]["earned"]<EPGPT)) then
		--EDebug("Both above");
		return EDB[a]["priority"]>EDB[b]["priority"];
	elseif(EDB[a]["earned"]>EPGPT and EDB[b]["earned"]<EPGPT) then
		--EDebug("A was above and B wasn't");
		return true;
	elseif(EDB[a]["earned"]<EPGPT and EDB[b]["earned"]>EPGPT) then
		--EDebug("B was above and A wasn't");
		return false;
	end
end

function Elgoh.LootShow()
	if(ElgohLootButton==nil) then
		ElgohLootButton={};
		local height=_G["LootButton1"]:GetHeight();
		for i=1, 4 do
			local name="ElgohLootButton"..i.."MS";
			ElgohLootButton[i]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
			ElgohLootButton[i]:SetWidth(height)
			ElgohLootButton[i]:SetHeight(height)
			local button=_G["LootButton"..i];
			ElgohLootButton[i]:SetPoint("TOP", button, "TOP", 0, 0);
			ElgohLootButton[i]:SetPoint("LEFT", _G["LootFrame"], "RIGHT", 0, 0);
			ElgohLootButton[i]:SetScript("OnClick", function(self) Elgoh_LootButton("MS", i); end);
			
			local name="ElgohLootButton"..i.."OS";
			ElgohLootButton[i+4]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
			ElgohLootButton[i+4]:SetWidth(height)
			ElgohLootButton[i+4]:SetHeight(height)
			ElgohLootButton[i+4]:SetPoint("TOP", button, "TOP", 0, 0);
			ElgohLootButton[i+4]:SetPoint("LEFT", _G["ElgohLootButton"..i.."MS"], "RIGHT", 0, 0);
			ElgohLootButton[i+4]:SetScript("OnClick", function(self) Elgoh_LootButton("OS", i); end);			
			
			local name="ElgohLootButton"..i.."DE";
			ElgohLootButton[i+8]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
			ElgohLootButton[i+8]:SetWidth(height)
			ElgohLootButton[i+8]:SetHeight(height)
			ElgohLootButton[i+8]:SetPoint("TOP", button, "TOP", 0, 0);
			ElgohLootButton[i+8]:SetPoint("LEFT", _G["ElgohLootButton"..i.."OS"], "RIGHT", 0, 0);
			ElgohLootButton[i+8]:SetScript("OnClick", function(self) Elgoh_LootButton("DE", i); end);
			
			ElgohLootButton[i]:SetText("MS");
			ElgohLootButton[i+4]:SetText("OS");
			ElgohLootButton[i+8]:SetText("DE");
			
			ElgohLootButton[i]:Hide();
			ElgohLootButton[i+4]:Hide();
			ElgohLootButton[i+8]:Hide();
		end
	end
	if(ElgohLootButtonLink==nil) then
		ElgohLootButtonLink=CreateFrame("Button",nil,_G["LootFrame"],"UIPanelButtonTemplate")
		ElgohLootButtonLink:SetWidth(100)
		ElgohLootButtonLink:SetHeight(25)
		ElgohLootButtonLink:SetPoint("TOP", _G["LootFrame"], "TOP", 0, -30);
		ElgohLootButtonLink:SetPoint("LEFT", _G["LootFrame"], "LEFT", 60, 0);
		ElgohLootButtonLink:SetScript("OnClick", Elgoh.LinkLoot);
		ElgohLootButtonLink:SetText("Link");
		ElgohLootButtonLink:Hide();
	end
	for i=1,GetNumLootItems() do
		local _,lootName,_,rarity = GetLootSlotInfo(i);
		if(LootSlotHasItem(i) and (rarity>=GetLootThreshold() or (rarity>=0 and Elgoh.Settings.Debug==1))) then
			ElgohLootButtonLink:Show();
			break;
		end 
		ElgohLootButtonLink:Hide();
	end
	if(LootFrame.page==nil) then LootFrame.page=1; end
	for i=1, GetNumGroupMembers(), 1 do 
		local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
		if(Elgoh.Settings.Debug==1 or (name==UnitName("PLAYER") and isML)) then
			for i=1,4 do
				local _,_,_,rarity = GetLootSlotInfo(i+(3*(LootFrame.page-1)));
				if(LootSlotHasItem(i+(3*(LootFrame.page-1))) and (rarity>=GetLootThreshold() or Elgoh.Settings.Debug==1)) then
					if(i==4 and LootFrameDownButton:IsShown()) then break; end
					ElgohLootButton[i]:Show();
					ElgohLootButton[i+4]:Show();
					ElgohLootButton[i+8]:Show();
				else
					ElgohLootButton[i]:Hide();
					ElgohLootButton[i+4]:Hide();
					ElgohLootButton[i+8]:Hide();
				end
			end
			return;
		end
	end
end

function Elgoh.LinkLoot()
	local epics=0;
	local what=UnitName("TARGET");
	for i=1,GetNumGroupMembers() do
		if(what==UnitName("Raid"..i)) then what=":"; return; end
	end
	if(what==nil) then what=":"; else what=" from "..what; end
	if(IsInRaid()) then SendChatMessage("Linking loot"..what, "RAID"); else SendChatMessage("Linking loot"..what, "SAY"); end
	for i=1,GetNumLootItems() do
		local _,lootName,_,rarity = GetLootSlotInfo(i);
		if(LootSlotHasItem(i) and (rarity>=GetLootThreshold() or (rarity>=0 and Elgoh.Settings.Debug==1))) then
			epics=epics+1;
			if(IsInRaid() and GetLootSlotLink(i)~=nil) then SendChatMessage(epics..": "..GetLootSlotLink(i), "RAID"); end
		end 
	end
end