Elgoh.frmSettings = CreateFrame("Frame");
Elgoh.frmSettings.name = "Elgoh";
--Elgoh.frmSettings:Hide();
--- Builds a standard tooltip for a control.
function Elgoh.frmSettings:ControlOnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT" );
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1 );
end

Elgoh.Settings_Default={
	["EPGPThreshhold"]=750,
	["Debug"]=0,
	["OSDiscount"]=0.5,
	["MiniLvl"]=476,
	["BreaktimeString"]="Breaktime! Be back in TIME minutes!",
	["MSString"]="Roll for ITEM Mainspec",
	["OSString"]="Roll for ITEM Offspec",
	["StartBonus"]=50,
}

Elgoh.frmSettings.okay = function() 
	Elgoh.Settings={};
	Elgoh.Settings["Debug"]=Debug:GetChecked();
	Elgoh.Settings["BreaktimeString"]=Elgoh.frmSettings:GetText();
	Elgoh.Settings["MiniLvl"]=tonumber(ilvlBox:GetText());
	Elgoh.Settings["EPGPThreshhold"]=tonumber(threshholdBox:GetText());
	Elgoh.Settings["OSDiscount"]=tonumber(discountBox:GetText());
	Elgoh.Settings["MSString"]=MainspecLabel:GetText();
	Elgoh.Settings["OSString"]=Offspec:GetText();
	Elgoh.Settings["StartBonus"]=tonumber(StartBonusBox:GetText());
	ElgohSettingsPre=Elgoh.Settings;
end

Elgoh.frmSettings.cancel = function() 
	Debug:SetChecked(Elgoh.Settings.Debug);
	Breaktime:SetText(Elgoh.Settings.BreaktimeString);
	ilvlBox:SetText(Elgoh.Settings.MiniLvl);
	threshholdBox:SetText(Elgoh.Settings.EPGPThreshhold)
	Offspec:SetText(Elgoh.Settings.OSString);
	MainspecLabel:SetText(Elgoh.Settings.MSString);
	discountBox:SetText(Elgoh.Settings.OSDiscount);
	StartBonusBox:SetText(Elgoh.Settings.StartBonus);
end

Elgoh.frmSettings.default = function() 
	Elgoh.Settings=Elgoh.Settings_Default;
	cancel();
end

function Elgoh.OptionsLoaded()
	cancel();
	Elgoh.frmSettings:SetScript("OnShow", nil);
end

-- Pane title
Title = Elgoh.frmSettings:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge" );
Title:SetPoint( "TOPLEFT", 16, -16 );
Title:SetText("ELGoH");
SubText = Elgoh.frmSettings:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall" );
SubText:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -8 );
SubText:SetPoint("RIGHT", -32, 0 );
SubText:SetHeight(32);
SubText:SetJustifyH( "LEFT" );
SubText:SetJustifyV( "TOP" );
SubText:SetText("General settings, this part is a work in progress so more settings will be added with each update");

-- Miscellaneous checkboxes
Debug = CreateFrame("CheckButton", "ElgohDebugCheckbox", Elgoh.frmSettings, "InterfaceOptionsCheckButtonTemplate");
Debug:SetPoint( "LEFT", SubText, "LEFT", -2, 0 );
Debug:SetPoint( "BOTTOM", Elgoh.frmSettings, "BOTTOM", 0, 10 );
getglobal(Debug:GetName() .. "Text"):SetText("Enable Debug Mode");
Debug.tooltipText = "Enable Debug Mode";

-- Breaktime
BreakLabel = Elgoh.frmSettings:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
BreakLabel:SetPoint( "TOPLEFT", SubText, "BOTTOMLEFT", -0, -10 );
BreakLabel:SetText("Text to post during /breaktime");

Breaktime = CreateFrame("EditBox", "ElgohBreaktimeBox", Elgoh.frmSettings, "InputBoxTemplate")
Breaktime:SetWidth(400)
Breaktime:SetHeight(20)
Breaktime:SetPoint("TOP", BreakLabel, "TOP", 0,2);
Breaktime:SetPoint("LEFT", BreakLabel, "RIGHT", 15,0);
Breaktime:SetAutoFocus(false)
Breaktime:SetScript("OnEnterPressed", function() Elgoh.frmSettings:ClearFocus(); end)
Breaktime.tooltipText="TIme will be replaced with the time in minutes";
Breaktime:SetScript( "OnEnter", ControlOnEnter);
Breaktime:SetScript( "OnLeave", GameTooltip_Hide);

-- Mainspec
MainspecLabel = Elgoh.frmSettings:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
MainspecLabel:SetPoint( "TOPLEFT", BreakLabel, "BOTTOMLEFT", -0, -30 );
MainspecLabel:SetText("What to post for Mainspec Rolls");

Mainspec = CreateFrame("EditBox", "Elgoh.MainspecBox", Elgoh.frmSettings, "InputBoxTemplate")
Mainspec:SetWidth(400)
Mainspec:SetHeight(20)
Mainspec:SetPoint("TOP", MainspecLabel, "TOP", 0,2);
Mainspec:SetPoint("LEFT",Breaktime, "LEFT", 0,0);
Mainspec:SetAutoFocus(false)
Mainspec:SetScript("OnEnterPressed", function()MainspecLabel:ClearFocus(); end)
Mainspec.tooltipText="\"ITEM\" will be replace with the item link";
Mainspec:SetScript( "OnEnter",ControlOnEnter);
Mainspec:SetScript( "OnLeave", GameTooltip_Hide);

-- Offspec
OffspecLabel = Elgoh.frmSettings:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
OffspecLabel:SetPoint( "TOPLEFT", MainspecLabel, "BOTTOMLEFT", -0, -10 );
OffspecLabel:SetText("What to post for Offspec Rolls");

Offspec = CreateFrame("EditBox", "ElgohOffspecBox", Elgoh.frmSettings, "InputBoxTemplate")
Offspec:SetWidth(400)
Offspec:SetHeight(20)
Offspec:SetPoint("TOP", OffspecLabel, "TOP", 0,2);
Offspec:SetPoint("LEFT",Breaktime, "LEFT", 0,0);
Offspec:SetAutoFocus(false)
Offspec:SetScript("OnEnterPressed", function()Offspec:ClearFocus(); end)
Offspec.tooltipText="\"ITEM\" will be replace with the item link";
Offspec:SetScript( "OnEnter",ControlOnEnter);
Offspec:SetScript( "OnLeave", GameTooltip_Hide);

--ItemLevel
ilvlBox = CreateFrame("EditBox", "ElgohilvlBox", Elgoh.frmSettings, "InputBoxTemplate")
ilvlBox:SetWidth(60)
ilvlBox:SetHeight(20)
ilvlBox:SetPoint("TOP",Offspec, "TOP", 0,0);
ilvlBox:SetPoint("LEFT",Breaktime, "LEFT", 0,0);
ilvlBox:SetAutoFocus(false)
ilvlBox:SetJustifyH("CENTER");
ilvlBox:SetScript("OnEnterPressed", function()ilvlBox:ClearFocus(); end)
ilvlBox.tooltipText="The minimum Item Level of gear to display EPGP values for";
ilvlBox:SetScript( "OnEnter",ControlOnEnter );
ilvlBox:SetScript( "OnLeave", GameTooltip_Hide );

--Threshhold
threshholdBox = CreateFrame("EditBox", "ElgohThreshholdBox", Elgoh.frmSettings, "InputBoxTemplate")
threshholdBox:SetWidth(60)
threshholdBox:SetHeight(20)
threshholdBox:SetPoint("TOP",ilvlBox, "TOP", 0,0);
threshholdBox:SetPoint("LEFT",ilvlBox, "RIGHT", 30,0);
threshholdBox:SetAutoFocus(false)
threshholdBox:SetJustifyH("CENTER");
threshholdBox:SetScript("OnEnterPressed", function()threshholdBox:ClearFocus(); end)
threshholdBox.tooltipText="The EPGP Threshhold. This only matters if you are the Master Looter";
threshholdBox:SetScript( "OnEnter",ControlOnEnter );
threshholdBox:SetScript( "OnLeave", GameTooltip_Hide );

--Discount
discountBox = CreateFrame("EditBox", "Elgoh.DiscountBox", Elgoh.frmSettings, "InputBoxTemplate")
discountBox:SetWidth(60)
discountBox:SetHeight(20)
discountBox:SetPoint("TOP",ilvlBox, "TOP", 0,0);
discountBox:SetPoint("LEFT",threshholdBox, "RIGHT", 30,0);
discountBox:SetAutoFocus(false)
discountBox:SetJustifyH("CENTER");
discountBox:SetScript("OnEnterPressed", function()discountBox:ClearFocus(); end)
discountBox.tooltipText="The EPGP discount for Off-SPec gear. OriginalPrice x Discount, set to 1 for no discount";
discountBox:SetScript( "OnEnter",ControlOnEnter );
discountBox:SetScript( "OnLeave", GameTooltip_Hide );

--StartBonus
StartBonusBox = CreateFrame("EditBox", "Elgoh.StartBonusBox", Elgoh.frmSettings, "InputBoxTemplate")
StartBonusBox:SetWidth(60)
StartBonusBox:SetHeight(20)
StartBonusBox:SetPoint("TOP",ilvlBox, "TOP", 0,0);
StartBonusBox:SetPoint("LEFT",discountBox, "RIGHT", 30,0);
StartBonusBox:SetAutoFocus(false)
StartBonusBox:SetJustifyH("CENTER");
StartBonusBox:SetScript("OnEnterPressed", function()StartBonusBox:ClearFocus(); end)
StartBonusBox.tooltipText="The bonus EP to award anyone on the start bonus list";
StartBonusBox:SetScript( "OnEnter",ControlOnEnter );
StartBonusBox:SetScript( "OnLeave", GameTooltip_Hide );

Elgoh.frmSettings:SetScript("OnShow", Elgoh.OptionsLoaded);
InterfaceOptions_AddCategory(Elgoh.frmSettings);